function K2BTagEnabledField(JQuery) {
	this.$ = JQuery;
	this.Prefix = "";
	this.CandidateTags = null;
	this.Class = null;
	var _uc = this;
	
	this.GetControlName = function(){
		$container = $(this.getContainerControl());
		return $container.attr('id') + '_field';
	}
	
	this.SetClass = function (data) {
		this.Class = data;
	}

	this.GetClass = function () {
		return this.Class;
	}
	
	this.SetValue = function (data) {
		this.$("#"+this.GetControlName()).val(data)		
	}

	this.GetValue = function () {
		return this.$("#"+this.GetControlName()).val();
	}

	this.SetCandidateTags = function (data) {
		this.CandidateTags = data;
		this.updateSuggestions();
	}

	this.GetCandidateTags = function () {
		return this.CandidateTags;
	}
	
	this.SetPrefix = function (data) {
		this.Prefix = data;
	}

	this.GetPrefix = function () {
		return this.Prefix;
	}
	
	this.GetCursorPosition = function() {
		var input = document.getElementById(this.GetControlName());
        if (!input) return; // No (input) element found
        if ('selectionStart' in input) {
            // Standard-compliant browsers
            return input.selectionStart;
        } else if (document.selection) {
            // IE
            input.focus();
            var sel = document.selection.createRange();
            var selLen = document.selection.createRange().text.length;
            sel.moveStart('character', -input.value.length);
            return sel.text.length - selLen;
        }
	}

	this.prefixFinder = /\B@([A-Za-z0-9._@]*)$/;
	
	this.IsCreatingTag = function(){
		var textUpToEdition = this.$("#"+this.GetControlName()).val().substring(0, this.GetCursorPosition());
		var match = this.prefixFinder.exec(textUpToEdition);
		
		if(match != null){
			this.Prefix = match[1];
			console.log(match[1]);
			return true;
		}else{
			this.Prefix = null;
			return false;
		}
	}
	
	this.triggerSuggestions = function() {
		if(this.IsCreatingTag()){
			if (typeof(this.SeekSuggestions) == 'function')
			{
				this.SeekSuggestions();
			}
		}
		this.updateSuggestions();
	}
	
	this.updateSuggestions = function() {
		var results = this.$("#"+this.GetControlName()+"_Results");
		results.hide();
		results.empty();
		if(_uc.Prefix != null && _uc.Prefix != ""){
			var filteredCandidates = this.$(this.CandidateTags).filter(function(i, item) { return item.Code.startsWith(_uc.Prefix) });
			
			if(filteredCandidates.length > 0){
				results.show();
				results.empty();
				this.$(filteredCandidates).each(function(i, item){
					
					var link = _uc.$("<a>");
					link.attr("href", "#");
					
					var resultItem = _uc.$("<div>");
					resultItem.addClass("K2BT_TagEnabledFieldResult");
					link.append(resultItem);
					
					var description = _uc.$("<div>");
					description.addClass("K2BT_TagEnabledFieldDescription");
					description.text(item.Description);
					resultItem.append(description);
					
					var code = _uc.$("<div>");
					code.addClass("K2BT_TagEnabledFieldCode");
					code.text(item.Code);
					resultItem.append(code);
					
					results.append(link);
					link.attr("data-k2btools-tagcode", item.Code);
					_uc.$(link).on("click", _uc.itemClick);
				});
			}
		}
	}
	
	this.tagsAvailable = function(){
		return _uc.$("#"+_uc.GetControlName()+"_Results").children().length != 0;
	}
	
	this.processKeydown = function(event) {
		if(_uc.tagsAvailable()){
			var currentFocus = _uc.$(document.activeElement);
			if(event.which == 40){ // Down
				if(currentFocus[0].nodeName.toLowerCase() == "textarea"){
					_uc.$(".K2BT_TagEnabledFieldResults a:first-child").focus();
					event.preventDefault();
				}else if (currentFocus[0].nodeName.toLowerCase() == "a"){
					if(currentFocus.next().length > 0)
						currentFocus.next().focus();
					event.preventDefault();
				}
			}else if(event.which == 38){ //Up
				if(currentFocus[0].nodeName.toLowerCase() == "a"){
					if(currentFocus.prev().length > 0)
						currentFocus.prev().focus();
					else
						_uc.$("#"+_uc.GetControlName()).focus();
					
					event.preventDefault();
				}else if(currentFocus[0].nodeName.toLowerCase() == "textarea"){
					_uc.textChange();
				}
			}else if (event.which == 13 || event.which == 9) { // Enter or Tab
				if(currentFocus[0].nodeName.toLowerCase() == "a"){
					$(currentFocus[0]).trigger('click');
					event.preventDefault();
				}
			}
		}
	}
	
	this.emojimap = [
		{text: ":)", character: "🙂"},
		{text: "X-(", character:"😠"},
		{text: '</3', character: '💔'},
		{text: '<3', character: '❤'},
		{text: 'B-)', character: '😎'},
		{text: ":'(", character: '😢'},
		{text: '}:-)', character: '😈'},
		{text: ':(', character: '😞'},
		{text: ':-(', character: '😞'},
		{text: ':D', character: '😀'},
		{text: ':-)', character: '🙂'},
		{text: ':-P', character: '😛'},
		{text: ':P', character: '😛'},
		{text: ';)', character: '😉'},
		{text: ';-)', character: '😉'},
		{text: '=)', character: '😊'},
		{text: ':-/', character: '😕'},
		{text: ':-X', character: '😘'},
		{text: ':-*', character: '😘'},
		{text: ':*', character: '😘'},
	];
	
	this.timer = null;
	
	this.textChange = function(){
		if(this.timer != null)
			window.clearTimeout(this.timer);
		
		if(_uc.$("#"+_uc.GetControlName()).val().length != 0){
			_uc.$("#"+_uc.GetControlName()).addClass("K2BT_TagEnabledFieldEditing");
			var textUpToEdition = _uc.$("#"+_uc.GetControlName()).val().substring(0, _uc.GetCursorPosition());
			_uc.$(_uc.emojimap).each(function(i, item){
				if(textUpToEdition.endsWith(item.text)){
					var result = _uc.$("#"+_uc.GetControlName()).val().substring(0, _uc.GetCursorPosition()-item.text.length) + item.character + _uc.$("#"+_uc.GetControlName()).val().substring(_uc.GetCursorPosition());
					_uc.$("#"+_uc.GetControlName()).val(result);
					return false;
				}
			});
			
			this.timer = window.setTimeout(function(){
				_uc.triggerSuggestions();
			}, 600);
		}else{
			_uc.$("#"+_uc.GetControlName()).removeClass("K2BT_TagEnabledFieldEditing");
		}
	}
	
	this.itemClick = function(e){
		var a = _uc.$(e.target).closest("A[data-k2btools-tagcode]");
		var code = _uc.$(a).attr("data-k2btools-tagcode");
		
		var textUpToEdition = _uc.$("#"+_uc.GetControlName()).val().substring(0, _uc.GetCursorPosition());
		textUpToEdition = textUpToEdition.replace(_uc.prefixFinder, "@"+code+" ");
		
		var textAfterEdition = _uc.$("#"+_uc.GetControlName()).val().substring(_uc.GetCursorPosition());
		_uc.$("#"+_uc.GetControlName()).val(textUpToEdition+textAfterEdition);
		
		_uc.$("#"+_uc.GetControlName()).focus();
		_uc.textChange();
		return false;
	}
	
	this.show = function () {
		if(!this.IsPostBack)
		{
			var container = this.$("<div>");
			container.addClass("K2BT_TagEnabledFieldContainer");
			
			var input = this.$("<textarea type=\"text\" style=\"width:100%;\" />");
			input.attr("id", this.GetControlName());
			input.addClass(this.Class)
			input.attr("placeholder", this.InviteMessage);
			container.append(input);
			
			var results = this.$("<div>");
			results.attr("id", this.GetControlName()+"_Results")
			results.addClass("K2BT_TagEnabledFieldResults");
			container.append(results);
			
			this.setHtml(container[0].outerHTML);
			
			searchField = $('#'+this.GetControlName());
			var timer;
			this.$(searchField).bind('input', this.textChange);
			
			this.$(".K2BT_TagEnabledFieldContainer").keydown(this.processKeydown);
			
			this.updateSuggestions();
		}
	}
}
